/* cut 'n pasted from fire's source code (http://fire.sourceforge.net) */
/* blame mgr for this ugly hack */

/* taken from GPGController.m of Fire.app0.32.h */

//
//  GPGController.m
//  Fire
//
//  Created by jesus on Sat Dec 29 2001.
//  Copyright (c) 2001 OmniTI, Inc. All rights reserved.
//  Licensed under the same license as Fire itself.

/* The file Fire-README.txt says: */

// Fire.app is released under the terms of the GPL (enclosed with this package).
//  
// Fire.app is copyright 1999-2003 epicware, Inc. (epicware@epicware.com).
// 
// See the source code for the individual services for the copyright and
// license information for each bundle.

#include <unistd.h>

static const unsigned char reverse_64[256] = {
    /* ASCII table */
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 62, 64, 64, 64, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 64, 64, 64, 64,
    64,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 64, 64, 64, 64, 64,
    64, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64
};

// This destroys the input... It expects the base64 message to follow "\n\n" or 
// start immediately. 
static size_t base64_decode(char *buffer) {
  size_t len = 0;
  int nb = 0, nbd;
  char *cp, *ncp;
    
  cp = strstr(buffer,"\n\n");
  if(!cp) cp = buffer;
  else cp+=2;
  ncp = cp;
  while (reverse_64[(int)*(ncp++)] <= 63) nb++;
  nbd = ((nb + 3) / 4) * 3;

  ncp = cp;
  while (nb > 4) {
    buffer[len++] = (reverse_64[(int)ncp[0]] << 2 | reverse_64[(int)ncp[1]] 
		     >> 4);
    buffer[len++] = (reverse_64[(int)ncp[1]] << 4 | reverse_64[(int)ncp[2]] 
		     >> 2);
    buffer[len++] = (reverse_64[(int)ncp[2]] << 6 | reverse_64[(int)ncp[3]])
      ;
    ncp += 4;
    nb -= 4;
  }
  if (nb > 1)
    buffer[len++] = (reverse_64[(int)ncp[0]] << 2 | reverse_64[(int)ncp[1]] 
		     >> 4);
  if (nb > 2)
    buffer[len++] = (reverse_64[(int)ncp[1]] << 4 | reverse_64[(int)ncp[2]] 
		     >> 2);
  if (nb > 3)
    buffer[len++] = (reverse_64[(int)ncp[2]] << 6 | reverse_64[(int)ncp[3]])
      ;
  buffer[len] = '\0';
    
  return len;
}

int main(int argc, const char *argv[]) {
  char *encbuffer;
  size_t retlen;

/*   char *foo = "aGFsbG8gbeR4bGU=";
/* //"a29tbXQgZGFzIGpldHp0IHZlcnNjaGz8c3NlbHQgb2RlciBudXIgc2lnbmllcnQgYW4/"; */
/*   encbuffer = (char *)malloc( (strlen(foo) + 1) * sizeof(char)); */
/*   strcpy(encbuffer, foo); */

  if ( argc !=  2 ) {
    printf( "usage: %s <base64 encoded text>\n", argv[0] );
    exit(1);
  }

  encbuffer = (char *)argv[1];
/*   printf( "%s\n", encbuffer); */

  retlen = base64_decode(encbuffer);
/*   if (retlen > 0) { */
/*     ; */
/*   } else { */
/*     // Data was not properly Base64 encoded so it is not valid */
/*     strcpy(encbuffer, foo); */
/*   } */

  printf( "%s\n", encbuffer );
  return(0);
}
